local AddonName, GGL = ...
local GUI = GGL.GUI
local Global = {}
GGL.Options.Challenge = Global

local L = GGL.Locale

-- lua

-- WoW

-- Libs
local AceGUI = LibStub("AceGUI-3.0")

-- ##################
-- local
-- ##################

-- ##################
-- local helper
-- ##################


-- ##################
-- options
-- ##################

local function Options(AceGUI, container)

    local sessionOption = GGL.Session:Options_Add(container, "A", GGL.db.SoloOptions)

    if not sessionOption then return end

    sessionOption:UpdateGUI(true, false)
    sessionOption:Refresh()

    -- resize scrollFrame
    if sessionOption.gui.scroll then
        sessionOption.gui.scroll:DoLayout()
    end
end

-- Add into Options
GGL.Options:AddIntoTree(Options, L["Solo"], "solo")