local AddonName, GGL = ...
local Templates = GGL.Templates

local QuestChallenge, QuestChallengeHelper = Templates:Register("QuestChallenge", "Challenge")

-- lua

-- wow

-- ##################
-- local
-- ##################
local SessionSave = {}

-- ##################
-- static
-- ##################
local Static = {}
Templates.QuestChallenge = Static



-- ##################
-- template
-- ##################
QuestChallenge.sessionFormat = "QC%d"
QuestChallenge.sessionType = "QC"

function QuestChallenge:Constructor(sessionDB, sessionID)
    if sessionID and SessionSave[sessionID] then
        return SessionSave[sessionID]
    end
    -- base
    self:CallBaseFunction("Challenge", "Constructor", sessionDB, sessionID)



    SessionSave[self.db.sessionID] = self
end


-- ## END
local function UnregisterAll(self)

    SessionSave[self.db.sessionID] = nil
end

function QuestChallenge:Unregister()
    self:CallBaseFunction("Challenge", "Unregister")

    UnregisterAll(self)
end

function QuestChallenge:Stop()
    self:CallBaseFunction("Challenge", "Stop")

    UnregisterAll(self)

    SessionSave[self.db.sessionID] = self
end

--- Close the session
function QuestChallenge:Close()
    self:CallBaseFunction("Challenge", "Close")

    UnregisterAll(self)
end